VERSION 5.00
Begin VB.UserControl GraphControl 
   AutoRedraw      =   -1  'True
   ClientHeight    =   3600
   ClientLeft      =   0
   ClientTop       =   0
   ClientWidth     =   4800
   ScaleHeight     =   3600
   ScaleWidth      =   4800
   Begin VB.Timer tmr 
      Interval        =   100
      Left            =   960
      Top             =   1080
   End
End
Attribute VB_Name = "GraphControl"
Attribute VB_GlobalNameSpace = False
Attribute VB_Creatable = True
Attribute VB_PredeclaredId = False
Attribute VB_Exposed = False
Option Explicit

Private m_LeftSpace     As Long             'fr LeftSpace-Property: Abstand zur linken Kante
Private m_RightSpace    As Long             'fr RightSpace-Property: Abstand zur rechten Kante
Private m_TopSpace      As Long             'fr TopSpace-Property: Abstand zur oberen Kante
Private m_BottomSpace   As Long             'fr BottomSpace-Property: Abstand zur unteren Kante
Private m_MaxTextLen_X  As Long             'Lnge der lngsten Beschriftung der X-Achse
Private m_MaxTextLen_Y  As Long             'Lnge der lngsten Beschriftung der Y-Achse

Private m_ArrowSize     As Long             'fr Arrow-Size-Property: Gre des Pfeiles
Private m_BorderStyle   As StyleProp        'fr BorderStyle-Property: Rahmenstil des Objektes
Private m_PointStyle    As PointStyleProp   'fr PointStyle-Property: Aussehen eines Punktes

Private m_BorderColor   As Long             'Farbe des Koordinatenkreuzes
Private m_ForeColor     As Long             'Farbe der Linien
Private m_PointColor    As Long             'Farbe der Punkte
Private m_GridColor     As Long             'Farbe der Linien an den Skalierungsschritten
Private m_BackColor     As Long             'Hintergrundsfarbe
Private m_ScaleColor    As Long             'Farbe der Skalierungstexte
Private m_VirtualColor  As Long             'Farbe fr virtuelle Linie
Private m_ShowVirtual   As Boolean          'Sollen virtuelle Linie gezeichnet werden?
Private m_ShowToolTips  As Boolean          'Sollen ToolTips gezeigt werden?
Private m_AutoScale     As Boolean          'Soll automatisch skaliert werden?
Private m_ScaleStep     As Long             'Schritte eines Skalierungsschrittes (wenn Autoscale = False...)

Private m_Datas         As Boolean          'Sind Daten vorhanden?

Private Points(ITEMCOUNT)   As DataType     'Hier werden die Informationen gespeichert, wo welcher Punkt liegt
Private LastPoint       As POINTAPI         'Laste Mauscursorposition
Private LastPointCount  As Long             'Zeit in 100ms, die der Cursor schon an der selben Zeit ist
Private ShowingToolTip  As Boolean          'Zeigt gerade einen ToolTip an

Const ScaleY        As Long = 15            'Gre fr die Skalierung unten
'---------------------------------------------------------

'Property LeftSpace: Abstand zur linken Kante
Public Property Get LeftSpace() As Long
Attribute LeftSpace.VB_Description = "Abstand zum linken Rand"
    LeftSpace = m_LeftSpace
End Property
Public Property Let LeftSpace(vNewValue As Long)
    m_LeftSpace = vNewValue
    UserControl_Resize
End Property

'Property RightSpace: Abstand zur rechten Kante
Public Property Get RightSpace() As Long
    RightSpace = m_RightSpace
End Property
Public Property Let RightSpace(vNewValue As Long)
    m_RightSpace = vNewValue
    UserControl_Resize
End Property

'Property TopSpace: Abstand zur oberen Kante
Public Property Get TopSpace() As Long
    TopSpace = m_TopSpace
End Property
Public Property Let TopSpace(vNewValue As Long)
    m_TopSpace = vNewValue
    UserControl_Resize
End Property

'Property BottomSpace: Abstand zur unteren Kante
Public Property Get BottomSpace() As Long
    BottomSpace = m_BottomSpace
End Property
Public Property Let BottomSpace(vNewValue As Long)
    m_BottomSpace = vNewValue
    UserControl_Resize
End Property

'Property Backcolor: Hintergrundsfarbe
Public Property Get BackColor() As Long
Attribute BackColor.VB_ProcData.VB_Invoke_Property = ";Darstellung"
Attribute BackColor.VB_UserMemId = -501
    BackColor = m_BackColor
End Property
Public Property Let BackColor(vNewValue As Long)
    m_BackColor = vNewValue
    UserControl_Resize
End Property

'Property Bordercolor: Farbe der Linien
Public Property Get BorderColor() As Long
    BorderColor = m_BorderColor
End Property
Public Property Let BorderColor(vNewValue As Long)
    m_BorderColor = vNewValue
    UserControl_Resize
End Property

'Property LineColor: Linienfarbe
Public Property Get LineColor() As Long
    LineColor = m_ForeColor
End Property
Public Property Let LineColor(vNewValue As Long)
    m_ForeColor = vNewValue
    UserControl_Resize
End Property

'Property ScaleColor: Farbe der Scalierungstexte
Public Property Get ScaleColor() As Long
    ScaleColor = m_ScaleColor
End Property
Public Property Let ScaleColor(vNewValue As Long)
    m_ScaleColor = vNewValue
    UserControl_Resize
End Property

'Property PointColor: Farbe der Punkte (wenn stlCircle ...)
Public Property Get PointColor() As Long
    PointColor = m_PointColor
End Property
Public Property Let PointColor(vNewValue As Long)
    m_PointColor = vNewValue
    UserControl_Resize
End Property

'Property GridColor: Farbe der Hilfslinien fr Skalierung
Public Property Get GridColor() As Long
    GridColor = m_GridColor
End Property
Public Property Let GridColor(vNewValue As Long)
    m_GridColor = vNewValue
    UserControl_Resize
End Property

'Property VirtualLineColor: Farbe der virtuellen Linien
Public Property Get VirtualLineColor() As Long
    VirtualLineColor = m_VirtualColor
End Property
Public Property Let VirtualColor(vNewValue As Long)
    m_VirtualColor = vNewValue
    UserControl_Resize
End Property

'Property ShowVirtualLine: Soll virtuelle Linie gezeigt werden
Public Property Get ShowVirtualLine() As Boolean
    ShowVirtualLine = m_ShowVirtual
End Property
Public Property Let ShowVirtualLine(vNewValue As Boolean)
    m_ShowVirtual = vNewValue
    UserControl_Resize
End Property

'Property PointStyle: Stil des Graphen
Public Property Get Style() As StyleProp
    PointStyle = m_BorderStyle
End Property
Public Property Let Style(vNewValue As StyleProp)
    m_BorderStyle = vNewValue
    UserControl_Resize
End Property

'Property PointStyle: Stil der Punkte
Public Property Get PointStyle() As PointStyleProp
    PointStyle = m_PointStyle
End Property
Public Property Let PointStyle(vNewValue As PointStyleProp)
    m_PointStyle = vNewValue
    UserControl_Resize
End Property

'Property ArrowSize: Gre des Pfeiles
Public Property Get ArrowSize() As Long
    ArrowSize = m_ArrowSize
End Property
Public Property Let ArrowSize(vNewValue As Long)
    m_ArrowSize = vNewValue
    UserControl_Resize
End Property

'Property ShowToolTips: Sollen ToolTips gezeigt werden?
Public Property Get ShowToolTips() As Boolean
    ShowToolTips = m_ShowToolTips
End Property
Public Property Let ShowToolTips(vNewValue As Boolean)
    m_ShowToolTips = vNewValue
    tmr.Enabled = vNewValue
    UserControl_Resize
End Property

'Property AutoScale: Automatische Skalierung?
Public Property Get AutoScale() As Boolean
    AutoScale = m_AutoScale
End Property
Public Property Let AutoScale(vNewValue As Boolean)
    m_AutoScale = vNewValue
    UserControl_Resize
End Property

'Property ScaleStep: Gre eines Skalierungsschrittes
Public Property Get ScaleStep() As Long
    ScaleStep = m_ScaleStep
End Property
Public Property Let ScaleStep(vNewValue As Long)
    m_ScaleStep = vNewValue
    UserControl_Resize
End Property
'-----------------------------------------------


Public Sub ReadDatas()
    m_Datas = True
    Call UserControl_Resize
End Sub

Public Sub EraseDatas()
    m_Datas = False
    Call UserControl_Resize
End Sub

Private Sub tmr_Timer()
    Dim MousePos        As POINTAPI
    'Mauscursorposition abfragen
    Call GetCursorPos(MousePos)
    
    'Ist die Mauscursorposition auf der selben Position wie letztes mal?
    If Near(MousePos.X, LastPoint.X) And Near(MousePos.Y, LastPoint.Y) Then
        'Speichern, wie lange der Mauscursor auf dieser Position ist
        LastPointCount = LastPointCount + 1
        
        'Lange genug, so dass Tooltip angezeigt werden sollte?
        If LastPointCount >= TOOLTIP_WAIT_TIME And m_Datas Then
            Dim MyPos   As POINTAPI
            Dim I       As Long
            
            'Position von Usercontrol auf dem Bildschirm
            Call ClientToScreen(hwnd, MyPos)
            For I = 0 To ITEMCOUNT
                'Ist der entsprechende Wert vielleicht nahe der Mausposition?
                'Wenn ja, wird ToolTip gesetzt
                If Near(Points(I).X + MyPos.X, MousePos.X) And Near(Points(I).Y + MyPos.Y, MousePos.Y) Then _
                    Call ShowToolTip(Points(I).Tag, Points(I).X, Points(I).Y)
            Next
        End If
    Else
        'Wird zur Zeit ein ToolTip angezeigt?
        If ShowingToolTip Then
            'Zerstren der ToolTips
            UserControl_Resize
            ShowingToolTip = False
        End If
        
        'Zhlvariable auf 0 setzen
        LastPointCount = 0
        LastPoint = MousePos
    End If
End Sub

Private Sub UserControl_Initialize()
    'AutoRedraw auf True, damit Inhalte immer sichtbar sind
    AutoRedraw = True
    'ScaleMode auf Pixel setzen
    ScaleMode = 3
    
    'Seitenabstnde auf 10 setzen
    m_LeftSpace = 10
    m_RightSpace = 10
    m_TopSpace = 10
    m_BottomSpace = 10
    
    'Standardfarben setzen
    m_BorderColor = 0       'Farbe von X- & Y-Achse
    m_BackColor = WHITE     'Hintergrund wei machen
    m_ForeColor = vbBlack   'Vordergrund ist schwarz
    m_PointColor = DEFAULT_POINT_COLOR
    m_VirtualColor = RGB(255, 0, 0) 'Standardfarbe der virtuellen Linien
    m_ShowVirtual = True    'Einstellen, das viruelle Linien gezeichnet werden
    
    'Darstellungsoptionen
    m_ArrowSize = 3         'Gre vom Pfeil
    m_BorderStyle = stlNormal 'Darstellung des Rahmens
    m_GridColor = INNER_BORDER_COLOR_XP 'Farbe der Skalierungslinien setzen
    
    m_MaxTextLen_Y = ScaleY 'Hhe der Y-Skalierung setzen
    ShowToolTips = True     'Standardmig werden ToolTips angezeigt ...
    m_AutoScale = True
End Sub

Private Sub UserControl_Resize()
    'Alte Zeichnung lschen
    Cls
    
    'Werte zurcksetzen
    m_MaxTextLen_X = 0
    m_MaxTextLen_Y = ScaleY
    
    Call DrawBackground     'Hintergrund zeichen
    If m_Datas Then _
        Call Inscript       'Beschriften, wenn Daten vorhanden
    Call DrawBorders        'Zeichnen von Koordinatenkreuz
End Sub

Private Sub DrawBackground()
    'Rahmen zeichnen, je nach Stil ein wenig anders ...
    If m_BorderStyle = stlNormal Then
        FillStyle = 0
        ForeColor = m_BackColor
        FillColor = m_BackColor
        Line (0, 0)-(ScaleWidth, ScaleHeight), , BF
        FillStyle = 1
        
        Line (1, 1)-(1, ScaleHeight - 1), INNER_BORDER_COLOR_L
        Line (1, 1)-(ScaleWidth - 1, 1), INNER_BORDER_COLOR_L
        Line (1, ScaleHeight - 2)-(ScaleWidth - 2, ScaleHeight - 2), INNER_BORDER_COLOR_R
        Line (ScaleWidth - 2, 1)-(ScaleWidth - 2, ScaleHeight - 1), INNER_BORDER_COLOR_R
        Line (0, 0)-(0, ScaleHeight - 1), OUTER_BORDER_COLOR_L
        Line (0, 0)-(ScaleWidth - 1, 0), OUTER_BORDER_COLOR_L
        Line (0, ScaleHeight - 1)-(ScaleWidth - 1, ScaleHeight - 1), OUTER_BORDER_COLOR_R
        Line (ScaleWidth - 1, 0)-(ScaleWidth - 1, ScaleHeight), OUTER_BORDER_COLOR_R
    ElseIf m_BorderStyle = stlFlat Then
        FillStyle = 0
        ForeColor = 0
        FillColor = m_BackColor
        Line (0, 0)-(ScaleWidth - 1, ScaleHeight - 1), , B
        FillStyle = 1
    ElseIf m_BorderStyle = stlNone Then
        FillStyle = 0
        ForeColor = m_BackColor
        FillColor = m_BackColor
        Line (0, 0)-(ScaleWidth, ScaleHeight), , BF
        FillStyle = 1
    ElseIf m_BorderStyle = stlwinXP Then
        FillStyle = 0
        ForeColor = INNER_BORDER_COLOR_XP
        FillColor = m_BackColor
        RoundRect hDC, 1, 1, ScaleWidth - 1, ScaleHeight - 1, 4, 4
        FillStyle = 1
        ForeColor = OUTER_BORDER_COLOR_XP
        RoundRect hDC, 0, 0, ScaleWidth, ScaleHeight, 4, 4
    End If
End Sub

Private Sub DrawBorders()
    'X-Achse zeichnen
    Line (m_LeftSpace + m_MaxTextLen_X, m_TopSpace)-(m_LeftSpace + m_MaxTextLen_X, ScaleHeight - m_BottomSpace - m_MaxTextLen_Y), m_BorderColor
    Line (m_LeftSpace + m_MaxTextLen_X, m_TopSpace)-(m_LeftSpace + m_MaxTextLen_X - m_ArrowSize, m_TopSpace + m_ArrowSize), m_BorderColor
    Line (m_LeftSpace + m_MaxTextLen_X, m_TopSpace)-(m_LeftSpace + m_MaxTextLen_X + m_ArrowSize, m_TopSpace + m_ArrowSize), m_BorderColor
    
    'Y-Achse zeichnen
    Line (m_LeftSpace + m_MaxTextLen_X, ScaleHeight - m_BottomSpace - m_MaxTextLen_Y)-(ScaleWidth - m_RightSpace, ScaleHeight - m_BottomSpace - m_MaxTextLen_Y), m_BorderColor
    Line (ScaleWidth - m_RightSpace, ScaleHeight - m_BottomSpace - m_MaxTextLen_Y)-(ScaleWidth - m_RightSpace - m_ArrowSize, ScaleHeight - m_BottomSpace - m_MaxTextLen_Y - m_ArrowSize), m_BorderColor
    Line (ScaleWidth - m_RightSpace, ScaleHeight - m_BottomSpace - m_MaxTextLen_Y)-(ScaleWidth - m_RightSpace - m_ArrowSize, ScaleHeight - m_BottomSpace - m_MaxTextLen_Y + m_ArrowSize), m_BorderColor
End Sub

Private Sub Inscript()
    Const ScaleH        As Long = 30    'Mindestabstand von einer Beschriftung zur nchsten Beschriftung
    'Dim Scale_Step      As Long         'So gro ist ein Scalierungsschritt
    Dim InscrCount_Y    As Long         'So viele Beschriftungen an der Y-Achse
    Dim LastPoint_X     As Long
    Dim LastPoint_Y     As Long
    Dim OneStep_X       As Single       'Soviel Pixel mssen nach rechts gegangen werden, wenn man 15 Minuten weitergeht
    Dim OneStep_Y       As Single       'Soviel Pixel mssen nach oben gegangen werden pro cm
    Dim I               As Long         'zum Zhlen
    
    If AutoScale Then
        'Ausrechnen, wie genau beschriftet werden soll
        InscrCount_Y = Fix((ScaleHeight - m_TopSpace - m_BottomSpace - ScaleY) / ScaleH)
        If InscrCount_Y = 0 Then Exit Sub
        m_ScaleStep = GetScale(InscrCount_Y, MaxItem)
    Else
        If m_ScaleStep = 0 Then _
            Exit Sub
        If MaxItem / m_ScaleStep = Fix(MaxItem / m_ScaleStep) Then _
            InscrCount_Y = MaxItem / m_ScaleStep _
        Else _
            InscrCount_Y = Fix(MaxItem / m_ScaleStep) + 1
    End If
    
    'Beschriftung der X- und Y-Achse eintragen
    Call AddInscription(m_ScaleStep, InscrCount_Y)
    Call AddScaleY
    
    'Ausrechnen der Schritte
    OneStep_X = (ScaleWidth - m_LeftSpace - m_RightSpace - m_MaxTextLen_X) / ITEMCOUNT
    OneStep_Y = (ScaleHeight - m_TopSpace - m_BottomSpace - m_MaxTextLen_Y - 18.5) / (m_ScaleStep * InscrCount_Y)

    'Setzen der Vordergrundfarbe
    ForeColor = m_ForeColor
    
    'Alle Werte durchschleifen:
    For I = 0 To ITEMCOUNT
        'Testen, ob der momentane Wert angegeben war
        If Datas(I).Y <> -1 Then
            'Wenn letzter Punkt auch angegeben war, Linie zu diesem zeichnen, wenn nicht,
            'virtuelle Linie zum letzten angegebenen Punkt zeichnen, wenn dies eingestellt ist
            If I <> 0 Then _
                If Datas(I - 1).Y <> -1 Then _
                    Line (Fix(Datas(I).X * OneStep_X) + m_MaxTextLen_X + m_LeftSpace, ScaleHeight - (Fix(Datas(I).Y * OneStep_Y) + m_BottomSpace + m_MaxTextLen_Y))- _
                        (Fix(Datas(I - 1).X * OneStep_X) + m_LeftSpace + m_MaxTextLen_X, ScaleHeight - (Fix(Datas(I - 1).Y * OneStep_Y) + m_TopSpace + m_MaxTextLen_Y)), m_ForeColor _
                Else _
                    If LastPoint_X <> 0 And LastPoint_Y <> -1 Then _
                        If m_ShowVirtual Then _
                            Call VirtualLine(LastPoint_X, LastPoint_Y, Fix(Datas(I).X * OneStep_X) + m_LeftSpace + m_MaxTextLen_X, ScaleHeight - (Fix(Datas(I).Y * OneStep_Y) + m_TopSpace + m_MaxTextLen_Y))
            
            'Letzten Punkt malen, wenn er existiert
            If LastPoint_X <> 0 And LastPoint_Y <> -1 Then _
                Call Point(LastPoint_X, LastPoint_Y)
            
            'X- und Y-Werte speichern, damit nchste Linie gezeichnet werden kann ....
            LastPoint_X = Fix(Datas(I).X * OneStep_X) + m_MaxTextLen_X + m_LeftSpace
            LastPoint_Y = ScaleHeight - (Fix(Datas(I).Y * OneStep_Y) + m_TopSpace + m_MaxTextLen_Y)
            
            'Position auf dem Bildschirm und Tag (Beschreibung) auch in Points speichern,
            'damit beim spteren Maushoover ein ToolTip angezeigt werden kann
            Points(I).X = LastPoint_X
            Points(I).Y = LastPoint_Y
            Points(I).Tag = Datas(I).Tag
        End If
    Next
    
    'Letzten Punkt malen
    Call Point(LastPoint_X, LastPoint_Y)
End Sub

Private Sub VirtualLine(X1, Y1, X2, Y2)
    DrawStyle = 2
    Line (X1, Y1)-(X2, Y2), m_VirtualColor
    DrawStyle = 0
End Sub


Private Function PrintText(Text As String, X As Long, Y As Long, Optional OnlyCalc As Boolean = False) As Rect
    PrintText.Left = X
    PrintText.Top = Y
    Call DrawText(hDC, Text, -1, PrintText, DT_LEFT + DT_CALCRECT)
    If Not OnlyCalc Then Call DrawText(hDC, Text, -1, PrintText, DT_LEFT)
End Function

Private Function GetScale(ByRef InscrCount As Long, Max As Long) As Long
    Dim OneStep         As Long
    Dim FirstNumbers    As Long
    Dim Undo            As Single
    
    OneStep = Max / InscrCount
    If Len(CStr(OneStep)) = 1 Then
        Undo = 1 / 10
        OneStep = OneStep * 10
    End If
    
    'die ersten zwei Stellen extrahieren
    If Mid$(CStr(OneStep), 3) = String$(Len(CStr(OneStep)) - 2, "0") Then _
        FirstNumbers = CLng(Mid$(CStr(OneStep), 1, 2)) _
    Else _
        FirstNumbers = CLng(Mid$(CStr(RoundUp(OneStep, -CLng(Len(CStr(OneStep)) - 2))), 1, 2))
    
    If Undo = 0 Then
        Undo = 10 ^ Len(Mid$(CStr(OneStep), 3))
    Else
        FirstNumbers = FirstNumbers * Undo
        Undo = 10 ^ Len(Mid$(CStr(OneStep), 3))
    End If
    
    'Wert etwas verschnern (von 49 auf 50 etc ...)
    Select Case FirstNumbers
        Case 1
            GetScale = 1
        Case 2
            GetScale = 2
        Case Else
            GetScale = RoundUp(FirstNumbers / 5, 0) * 5
    End Select
    
    If Undo <> 0 Then _
        GetScale = GetScale * Undo
        
    Do Until GetScale * (InscrCount - 1) <= Max
        InscrCount = InscrCount - 1
    Loop
End Function

Public Function RoundUp(ByVal Number As Double, Optional ByVal NumDigitsAfterDecimal As Integer = 0) As Double
    RoundUp = Int(Number * 10 ^ NumDigitsAfterDecimal + 1) / 10 ^ NumDigitsAfterDecimal
End Function

Private Sub AddInscription(Scale_Step As Long, InscrCount As Long)
    Dim ScriptSize()    As Rect
    Dim OneStep_Y       As Single
    Dim I               As Long
    
   
    ReDim ScriptSize(InscrCount)
    ScriptSize(0) = PrintText("12:00", 0, 0, True) 'Nur ausrechnen, wie hoch Schrift ist
    
    OneStep_Y = (ScaleHeight - m_TopSpace * 2 - m_BottomSpace - m_MaxTextLen_Y - (ScriptSize(0).Top - ScriptSize(0).Bottom) / 2 - ScaleY) / InscrCount
    
    m_MaxTextLen_X = 0
    
    ForeColor = m_ScaleColor
    
    
    
    For I = 1 To InscrCount
        ScriptSize(I) = PrintText(Scale_Step * I, m_LeftSpace / 2, ScaleHeight - m_BottomSpace - ScaleY - OneStep_Y * I + (ScriptSize(0).Top - ScriptSize(0).Bottom) / 2)
        If ScriptSize(I).Right - ScriptSize(I).Left > m_MaxTextLen_X Then _
            m_MaxTextLen_X = ScriptSize(I).Right - ScriptSize(I).Left
    Next
    
    For I = 1 To InscrCount
        Line (m_LeftSpace + m_MaxTextLen_X, (ScriptSize(I).Top + ScriptSize(I).Bottom) / 2)- _
            (ScaleWidth - m_RightSpace, (ScriptSize(I).Top + ScriptSize(I).Bottom) / 2), m_GridColor
    Next
End Sub

Private Sub Point(X As Long, Y As Long)
    If m_PointStyle = stlCircle Then
        ForeColor = m_PointColor
        FillStyle = 0
        Circle (X, Y), 2
    End If
End Sub


Private Sub AddScaleY()
    Const ScaleH        As Long = 50    'Mindestabstand von einer Beschriftung zur nchsten Beschriftung
    Dim InscrCount As Long, OneStep As Single, I As Long
    InscrCount = Fix((ScaleWidth - m_LeftSpace - m_RightSpace - m_MaxTextLen_X) / ScaleH)
    ForeColor = m_ScaleColor
    
    If InscrCount = 0 Then _
        Exit Sub
    'Aud vernnfitge Anzahl der sichtbaren Stunden runden
    '(24 ist gut durch 1, 2, 3, 4, 6, 8, 12 und 24 teilbar;
    'wenn nicht solch eine Zahl, zur nchsten runter!):
    Select Case InscrCount
    Case 5
        InscrCount = 4
    Case 7
        InscrCount = 6
    Case 9 To 11
        InscrCount = 8
    Case 13 To 23
        InscrCount = 12
    End Select
    
    OneStep = (ScaleWidth - m_LeftSpace - m_RightSpace - m_MaxTextLen_X) / InscrCount
    For I = 0 To InscrCount - 1
        Call PrintText( _
          Format$(DateAdd("n", 15 * (24 / InscrCount) * 4 * I, DStartTime), "hh:mm"), _
          OneStep * I + m_LeftSpace + m_MaxTextLen_X - 14, _
          ScaleHeight - m_BottomSpace - m_MaxTextLen_Y / 2 _
        )
        Line (OneStep * I + m_LeftSpace + m_MaxTextLen_X, ScaleHeight - m_BottomSpace - m_MaxTextLen_Y)- _
            (OneStep * I + m_LeftSpace + m_MaxTextLen_X, m_TopSpace), m_GridColor
    Next
End Sub

Private Sub ShowToolTip(Text As String, X As Long, Y As Long)
    Call UserControl_Resize
    
    
    
    Dim Size    As Rect
    Dim BeforeC As Long
    Dim BeforeF As Long
    Dim BeforeS As Long
    
    BeforeC = ForeColor
    BeforeF = FillColor
    BeforeS = FillStyle
    
    FillColor = vbInfoBackground
    ForeColor = vbInfoText
    FillStyle = 0
    
    Size = PrintText(Text, X + 2, Y + 2, True)
    If X < ScaleWidth \ 2 Then
        If Y < ScaleHeight \ 2 Then
            Line (Size.Left - 2, Size.Top - 2 + 16)-(Size.Right + 2, Size.Bottom + 2 + 16), , B
            Call PrintText(Text, X + 2, Y + 2 + 16, False)
        Else
            Line (Size.Left - 2, Size.Top - (Size.Bottom - Size.Top) - 2)-(Size.Right + 2, Size.Top + 2), , B
            Call PrintText(Text, X + 2, Size.Top - (Size.Bottom - Size.Top), False)
        End If
    Else
        If Y < ScaleHeight \ 2 Then
            Line (Size.Left - (Size.Right - Size.Left) - 2, Size.Top - 2 + 16)-(Size.Left - 2, Size.Bottom + 2 + 16), , B
            Call PrintText(Text, Size.Left - (Size.Right - Size.Left), Y + 2 + 16, False)
        Else
            Line (Size.Left - (Size.Right - Size.Left) - 2, Size.Top - (Size.Bottom - Size.Top) - 2)-(Size.Left + 2, Size.Top + 2), , B
            Call PrintText(Text, Size.Left - (Size.Right - Size.Left), Size.Top - (Size.Bottom - Size.Top), False)
        End If
    End If
    FillColor = BeforeC
    ForeColor = BeforeF
    FillStyle = BeforeS
    ShowingToolTip = True
End Sub
