Attribute VB_Name = "ModDiagram"
Option Explicit

'----------------------------------------------------
' time constants
'----------------------------------------------------

Public Const QUARTS_PER_HOUR    As Long = 4
Public Const HOURS_PER_DAY      As Long = 24
Public Const QUARTS_PER_DAY     As Long = QUARTS_PER_HOUR * HOURS_PER_DAY
'----------------------------------------------------

'----------------------------------------------------
' public procedures
'----------------------------------------------------

'----------------------------------------------------
' GetIndexFromTime As Long
' calculates the values' array index from a given time
' - [IN] Time As Date: time to convert
' - returns the converted index
'----------------------------------------------------
Public Function GetIndexFromTime(Time As Date) As Long
    Dim Hour    As Long
    Dim Minute  As Long
    Dim Quarter As Long
    
    ' retrieve hours and minutes from time
    
    Hour = DatePart("h", Time)
    Minute = DatePart("n", Time)
    
    ' which quarter of the hour are we in?
    
    Quarter = Minute \ 15
    
    GetIndexFromTime = Hour * QUARTS_PER_HOUR + Quarter
End Function

'----------------------------------------------------
' Ceil As Long
' rounds a number to its next highest neighbour
' - [IN] Number As Long: the number to round
' - [IN] Significance As Long: number of significant digits
' - returns the rounded number
'----------------------------------------------------
Public Function Ceil(ByVal Number As Long, ByVal Significance As Long) As Long
    Ceil = -Int(-Number / 10 ^ Significance) * 10 ^ Significance
End Function

'----------------------------------------------------
' FileExists As Boolean
' - [IN] Path As String: path to file to test
' - returns whether the file exists
'----------------------------------------------------
Public Function FileExists(Path As String) As Boolean
    Const NotFile = vbDirectory Or vbVolume
    
    On Error Resume Next
    FileExists = (GetAttr(Path) And NotFile) = 0
    On Error GoTo 0
End Function
