VERSION 1.0 CLASS
BEGIN
  MultiUse = -1  'True
  Persistable = 0  'NotPersistable
  DataBindingBehavior = 0  'vbNone
  DataSourceBehavior  = 0  'vbNone
  MTSTransactionMode  = 0  'NotAnMTSObject
END
Attribute VB_Name = "clsLiniendiagramm"
Attribute VB_GlobalNameSpace = False
Attribute VB_Creatable = True
Attribute VB_PredeclaredId = False
Attribute VB_Exposed = False
Attribute VB_Ext_KEY = "SavedWithClassBuilder6" ,"Yes"
Attribute VB_Ext_KEY = "Top_Level" ,"Yes"
'Projekt: Klasse fr Liniendiagramm
'Autor  : Brunner Roland
'Version: 19.02.2004

Option Explicit

Const conNoData = -9876

Private Type Koord
    AX As Double
    AY As Double
    EX As Double
    EY As Double
End Type
    
Private mInit As Boolean
Private WithEvents mCanvas As PictureBox
Attribute mCanvas.VB_VarHelpID = -1
Private mMarkerShape As Shape
Private mMarker As Koord
Private mBorder As Koord
Private IsMouseDown As Boolean
Private mYDaten(1 To 96) As Double
Private mXDaten(1 To 96) As Date
Private mLineColor As Long
Private mCanvasBColor As Long
Private mDiagrammBColor As Long
Private mCanvasFColor As Long
Private mBorderColor As Long
Private mSkalaColor As Long
Private mAutoXMinMax As Boolean
Private mAutoYMinMax As Boolean
Private mMinX As Double, mMinY As Double
Private mMaxX As Double, mMaxY As Double
Private mValYGr As Double
Private mValYKl As Double
Private mSkalStepY As Double, mSkalStepX As Double

'Setzt das Maximum der X-Achse, Parameter ist ein Datum im Stringformat
'Ist das Datum ausserhalb des Bereichs wird nichts gendert
'Ist AutoMinMax eingestellt dann wird nichts gendert
Public Property Let MaxX(ByVal vData As String)
Dim i As Integer
If mAutoXMinMax Then Exit Property

i = PosArr(Format(vData, "hh:nn"), CDate(vData))
If i = -1 Then Exit Property

mMaxX = i
End Property

'Gibt den aktuellen Maximal-Wert der X-Achse zurck, Datum im Stringformat
Public Property Get MaxX() As String
Dim i As Integer

If mMaxX < 1 Or mMaxX > 96 Then mMaxX = 96

i = mMaxX

MaxX = mXDaten(i)

End Property

'Setzt das Minimum der X-Achse, Parameter ist ein Datum im Stringformat
'Ist das Datum ausserhalb des Bereichs wird nichts gendert
'Ist AutoMinMax eingestellt dann wird nichts gendert
Public Property Let MinX(ByVal vData As String)
Dim i As Integer
If mAutoXMinMax Then Exit Property
i = PosArr(Format(vData, "hh:nn"), CDate(vData))
If i = -1 Then Exit Property

mMinX = i
End Property

'Gibt den aktuellen Maximal-Wert der X-Achse zurck, Datum im Stringformat
Public Property Get MinX() As String
Dim i As Integer

If mMinX < 1 Or mMinX > 96 Then mMinX = 1

i = mMinX

MinX = mXDaten(i)
End Property

'Gibt den absoluten Maximal-Wert der X-Daten zurck, Datum im Stringformat
Public Property Get MaximumX() As String
MaximumX = mXDaten(96)
End Property

'Gibt den absoluten Minimal-Wert der X-Daten zurck, Datum im Stringformat
Public Property Get MinimumX() As String
MinimumX = mXDaten(1)
End Property

'Setzt den Maximalen Wert der Y-Achse, nur wenn nicht AutoMinMax eingestellt ist
Public Property Let MaxY(ByVal vData As Double)
If mAutoYMinMax Then Exit Property
mMaxY = vData
End Property

'Gibt den aktuellen Maximalen Wert der Y-Achse zurck
Public Property Get MaxY() As Double
MaxY = mMaxY
End Property

'Setzt den Minimalen Wert der Y-Achse, nur wenn nicht AutoMinMax eingestellt ist
Public Property Let MinY(ByVal vData As Double)
If mAutoYMinMax Then Exit Property
mMinY = vData
End Property

'Gibt den aktuellen Minimalen Wert der Y-Achse zurck
Public Property Get MinY() As Double
MinY = mMinY
End Property

'Da die Skalierung von X vorgegeben ist
'wird in dieser Funktion nur berprft ob Min und Max die richtigen Dimensionen haben
'und diese gegebenfals berichtigt
'Auerdem wird berechnet wiebreit eine Einheit in Pixel ist
Private Sub GetSkalaX(Breite As Double)
Dim tmp As Double


If mMinX > mMaxX Then
    tmp = mMinX
    mMinX = mMaxX
    mMaxX = tmp
End If
    
If mMinX = mMaxX Then mMaxX = mMaxX + 1


If mMinX < 1 Then mMinX = 1
If mMaxX > 96 Then mMaxX = 96

If (mMaxX - mMinX) = 0 Then
    mSkalStepX = Breite
Else
    mSkalStepX = Breite / (mMaxX - mMinX)
End If
End Sub

Private Function GetSkalaY(Hoehe As Double) As Double
'Berechnet die Skalierung und gibt die Y-Startpos retour
Dim Bereich As Double
Dim s As String

'Prfen und gegebefals ndern ob min < max
If mMinY > mMaxY Then
    Bereich = mMinY
    mMinY = mMaxY
    mMaxY = Bereich
End If
    
'Min sollte auch nicht gleich max sein
If mMinY = mMaxY Then mMaxY = mMaxY + 1
        
'Berechnen des Bereichs in der die Werte liegen
'Dieser wird durch 10 geteilt
Bereich = (mMaxY - mMinY) / 10
    
'Berechnen der Grossen und kleinen Skalierung
'da ich oben den Bereich schon durch 10 genommen habe ist mein grosser Bereich
'berechne aus der Stringlnge des Bereich ohne Komma meine grosse Skala
'Meine Kleine Skale ist einfach GrosseSkala / 10
s = Format(Int(Bereich))
mValYGr = 1 * 10 ^ Len(s)
mValYKl = mValYGr / 10

'Berechnen wie hoch eine Einheit in Pixel ist
If (mMaxY - mMinY) = 0 Then
    mSkalStepY = Hoehe
Else
    mSkalStepY = Hoehe / (mMaxY - mMinY)
End If

'Berechnen der Startposition der Skalierung, ist darum notwendig weil der
'Wertbereich ja nicht unbedingt mit der grossen oder kleinen Skalierung beginnt
If (mMinY Mod mValYGr) = 0 Or (mMinY Mod mValYKl) = 0 Then
    GetSkalaY = 0
Else
    GetSkalaY = (Int(mMinY / mValYKl) + 1) * mValYKl
    GetSkalaY = (GetSkalaY - mMinY) * mSkalStepY
End If
    
End Function

'Ob Min oder Max berechnet wird oder von User gesetzt wird
Public Property Let AutoYMinMax(ByVal vData As Boolean)
Dim i As Integer
mAutoYMinMax = vData
If mAutoYMinMax Then
    mMinY = 1E+100
    mMaxY = 1E-100
    For i = 1 To 96
        If mYDaten(i) <> conNoData And mYDaten(i) < mMinY Then mMinY = mYDaten(i)
        If mYDaten(i) <> conNoData And mYDaten(i) > mMaxY Then mMaxY = mYDaten(i)
    Next i
    If mMinY = 1E+100 Then mMinY = -100
    If mMaxY = 1E-100 Then mMaxY = 100
End If
End Property

'Ob Min oder Max berechnet wird oder von User gesetzt wird
Public Property Let AutoXMinMax(ByVal vData As Boolean)
Dim i As Integer
mAutoXMinMax = vData
If mAutoXMinMax Then
    mMinX = 97
    mMaxX = 0
    For i = 1 To 96
        If mYDaten(i) <> conNoData And i < mMinX Then mMinX = i
        If mYDaten(i) <> conNoData And i > mMaxX Then mMaxX = i
    Next i
    If mMinX = 97 Then mMinX = 1
    If mMaxX = 0 Then mMaxX = 96
End If
End Property

'Gibt zurck ob AutoMinMax gesetzt wird
Public Property Get AutoYMinMax() As Boolean
AutoYMinMax = mAutoYMinMax
End Property

'Gibt zurck ob AutoMinMax gesetzt wird
Public Property Get AutoXMinMax() As Boolean
AutoXMinMax = mAutoXMinMax
End Property

'Let und Get Eigenschaften fr Diagramm und Zeichenflchefarben
Public Property Let LineColor(ByVal vData As Long)
    mLineColor = vData
End Property

Public Property Let ZeichenFlaecheBackColor(ByVal vData As Long)
    mCanvasBColor = vData
End Property

Public Property Let ZeichenFlaecheForeColor(ByVal vData As Long)
    mCanvasFColor = vData
End Property

Public Property Let DiagrammBackColor(ByVal vData As Long)
    mDiagrammBColor = vData
End Property

Public Property Let DiagrammBorderColor(ByVal vData As Long)
    mBorderColor = vData
End Property

Public Property Let DiagrammSkalaColor(ByVal vData As Long)
    mSkalaColor = vData
End Property

Public Property Get LineColor() As Long
    LineColor = mLineColor
End Property

Public Property Get ZeichenFlaecheBackColor() As Long
    ZeichenFlaecheBackColor = mCanvasBColor
End Property

Public Property Get ZeichenFlaecheForeColor() As Long
    ZeichenFlaecheForeColor = mCanvasFColor
End Property

Public Property Get DiagrammBackColor() As Long
    DiagrammBackColor = mDiagrammBColor
End Property

Public Property Get DiagrammBorderColor() As Long
    DiagrammBorderColor = mBorderColor
End Property

Public Property Get DiagrammSkalaColor() As Long
    DiagrammSkalaColor = mSkalaColor
End Property

'Diese Funktion muss ausgefhrt werden, sonst knnen einige Funktionen und propertys
'nicht ausgefhrt werden
Public Sub Init(ByRef ZeichenFlaeche As PictureBox, ByRef Marker As Shape)

Set mCanvas = ZeichenFlaeche
mCanvas.ScaleMode = vbPixels

Set mMarkerShape = Marker
mMarkerShape.Visible = False
mMarkerShape.BorderWidth = 1
mMarkerShape.BorderStyle = vbBSDot
mMarkerShape.FillStyle = vbFSTransparent

mLineColor = vbRed
mCanvasBColor = vbWhite
mDiagrammBColor = vbGreen
mCanvasFColor = vbBlack
mBorderColor = vbBlack
mSkalaColor = vbCyan

mAutoXMinMax = True
mAutoYMinMax = True

InitYDaten
InitXDaten Now
mInit = True
End Sub

'Setzt alle Y-Daten zurck
Private Sub InitYDaten()
Dim i As Integer

'Setzt alle Daten im Y-DatenArray zurck
For i = 1 To 96
    mYDaten(i) = conNoData
Next

If mAutoYMinMax Then
    mMinY = conNoData
    mMaxY = conNoData
End If
End Sub

'Setzt alle X-Daten zurck
'Parameter ist der BisBereich(datum)
Private Function InitXDaten(ByVal ToTime As Date)
Dim s As Date
Dim i As Integer

i = Val(Format(ToTime, "nn"))
If i < 15 Then
    i = 0
ElseIf i < 30 Then
    i = 15
ElseIf i < 45 Then
    i = 30
Else
    i = 45
End If

s = CDate(Format(ToTime, "dd/mm/yyyy hh:") & Format(i, "00"))

For i = 96 To 1 Step -1
    mXDaten(i) = s
    s = DateAdd("n", -15, s)
Next i

If mAutoXMinMax Then
    mMinX = conNoData
    mMaxX = conNoData
End If
End Function

'Liest die Daten aus den App.PAth\Daten Verzeichnis, wenn sie vorhanden sind
'Der parameter ToTime bestimt die Datenfiles(max. 2)
'Wenn AutoMinMax gesetzt ist, wird Min/max berechnet

Public Function ReadData(ToTime As Date) As Boolean
'Liest das Datenfile ein, gibt False zurck falls Format falsch ist
Dim s As String, sFilename As String
Dim rc() As String
Dim i As Integer, j As Integer
Dim dVal As Double
Dim DataDatum As Date

On Error GoTo ErrHandling
'Daten zurcksetzten

InitYDaten
InitXDaten ToTime

'Minimum/maximum init.
If mAutoXMinMax Then
    mMinX = 97
    mMaxX = 0
End If
If mAutoYMinMax Then
    mMinY = 1E+100
    mMaxY = 1E-100
End If
For j = 1 To 2
    If j = 1 Then
        s = Format(mXDaten(1), "yyyymmdd") & ".txt"
    Else
        s = Format(mXDaten(96), "yyyymmdd") & ".txt"
    End If
    
    s = App.Path & "\Daten\" & s
    
    If s = sFilename Then Exit For
    sFilename = s
    
    If Dir(sFilename) <> "" Then
    
        Open sFilename For Input As #1
        
        'Einlesen des Datum
        Line Input #1, s
        If Not IsDate(s) Then Err.Raise vbError, , "File hat falsches Format!"
        DataDatum = CDate(s)
        'Leerzeile
        Line Input #1, s
        If Trim(s) <> "" Then Err.Raise vbError, , "File hat falsches Format!"
        'Einlesen der Daten

        Do While Not EOF(1)
            Line Input #1, s
            rc = Split(RTrim(s), " ")
            If UBound(rc) <> 1 Then Err.Raise vbError, , "File hat falsches Format!"
            If Not IsDate(rc(0)) Then Err.Raise vbError, , "File hat falsches Format!"
            'Bestimmen der Position im Array
            i = PosArr(rc(0), DataDatum)
            If i > -1 Then
                'Ermitteln des Wertes
                s = Replace(rc(1), ",", ".")
                If Not IsNumeric(s) Then Err.Raise vbError, , "File hat falsches Format!"
                mYDaten(i) = Val(s)
                'Min Max ermitteln
                If mAutoXMinMax Then
                    If i < mMinX Or mMinX = conNoData Then mMinX = i
                    If i > mMaxX Or mMaxX = conNoData Then mMaxX = i
                End If
                'Min Max ermitteln
                If mAutoYMinMax Then
                    If mYDaten(i) < mMinY Or mMinY = conNoData Then mMinY = mYDaten(i)
                    If mYDaten(i) > mMaxY Or mMaxY = conNoData Then mMaxY = mYDaten(i)
                End If
            End If
        Loop
        Close
    End If
Next j
If mAutoXMinMax Then
    If mMinX = 97 Then mMinX = 1
    If mMaxX = 0 Then mMaxX = 96
End If
If mAutoYMinMax Then
    If mMinY = 1E+100 Then mMinY = -100
    If mMaxY = 1E-100 Then mMaxY = 100
End If
ReadData = True

Close
Exit Function
ErrHandling:
    Close
    MsgBox Err.Description, vbCritical
    InitYDaten
End Function

'Berechnet aus der bergebenen Uhrzeit die Position im DatenArray
'Wenn der bergebene String nicht im richtigen Format ist wird -1
'zrckgegeben
Private Function PosArr(w As String, Datum As Date) As Integer

Dim ChkDate As Date
Dim i As Integer

ChkDate = Format(Datum, "dd/mm/yyyy ") & Format(w, "hh:nn")

PosArr = -1

For i = 1 To 96
    If Format(mXDaten(i), "dd/mm/yyyy hh:nn") = Format(ChkDate, "dd/mm/yyyy hh:nn") Then
        PosArr = i
        Exit For
    End If
Next i

End Function

'Zeichnet das Diagramm
Public Function Zeichne() As Boolean
Dim i As Integer
Dim L As Double, R As Double
Dim T As Double, B As Double
Dim X As Double, Y As Double
Dim tVal As Double
Dim s As String
Dim LastXPos As Double
Dim Gerade As Koord


If Not mInit Then
    MsgBox "Klasse muss initialisiert werden!", vbCritical
    Exit Function
End If
mCanvas.Cls

'Berechnen der Diagramm zeichenflche
'rechts Rand von 5% der Zeichenflche
R = mCanvas.ScaleWidth * 0.95
'Links rand fr Beschriftung + Skala
L = mCanvas.TextWidth(Format(Int(mMaxY))) * 1.5
'Oben Platz fr Datum
tVal = mCanvas.TextHeight("Test") * 1.2
T = tVal
B = mCanvas.ScaleHeight - tVal

'Setzten der Zeichenflche-Farbe und lschen derselben
mCanvas.BackColor = mCanvasBColor
mCanvas.ForeColor = mCanvasFColor
mCanvas.Cls

'Zeiche der Diagrammflche und des Titels
mCanvas.Line (L, T)-(R, B), mDiagrammBColor, BF

If Format(mXDaten(1), "dd/mm/yyyy") = Format(mXDaten(96), "dd/mm/yyyy") Then
    s = Format(mXDaten(1), "dd/mm/yyyy")
Else
    s = Format(mXDaten(1), "dd/mm/yyyy") & " - "
    s = s & Format(mXDaten(96), "dd/mm/yyyy")
End If

X = mCanvas.ScaleWidth - mCanvas.TextWidth(s)
X = X / 2
Y = tVal - mCanvas.TextHeight(s)
Y = Y / 2
mCanvas.CurrentX = X
mCanvas.CurrentY = Y
mCanvas.Print s

'Zeichne Y-Skalierung
'Ermitteln der Skalierung
Y = B - GetSkalaY(B - T)
tVal = mValYKl * (Int(mMinY / mValYKl))
If tVal < mMinY Then tVal = tVal + mValYKl
Do While Y > T
    If tVal Mod mValYGr = 0 Then
        mCanvas.DrawWidth = 2
        mCanvas.CurrentX = 0
        mCanvas.CurrentY = Y - (mCanvas.TextHeight("00") / 2)
        mCanvas.Print Format(tVal)
        mCanvas.Line (L, Y)-(L * 0.7, Y), mSkalaColor
    End If
    
    mCanvas.DrawWidth = 1
    mCanvas.Line (L * 0.8, Y)-(R, Y), mSkalaColor

    tVal = tVal + mValYKl
    Y = Y - (mValYKl * mSkalStepY)
Loop
'Zeichne X-Skalierung
GetSkalaX R - L
LastXPos = -1000
X = L
Y = mCanvas.ScaleHeight - B
For i = mMinX To mMaxX
    If i < LBound(mXDaten) Or i > UBound(mXDaten) Then Exit For
    s = Format(mXDaten(i), "hh:nn")
    If Right(s, 2) = "00" Then 'Grosse Skalierung
       
        mCanvas.DrawWidth = 2
        mCanvas.CurrentX = X - (mCanvas.TextWidth(s) / 2)
        mCanvas.CurrentY = B + (Y / 12)
        
        If X > LastXPos Then
            LastXPos = mCanvas.CurrentX + (mCanvas.TextWidth(s) * 1.5)
            mCanvas.Print s
        End If
        
        mCanvas.Line (X, B)-(X, B + Y / 12), mSkalaColor
    End If
    mCanvas.DrawWidth = 1
    mCanvas.Line (X, T)-(X, B + Y / 24), mSkalaColor
    X = X + mSkalStepX
    If X > R Then Exit For
Next i

mCanvas.DrawWidth = 2
For i = mMinX + 1 To mMaxX
    Gerade.AX = i - 1
    Gerade.AY = (mYDaten(i - 1))
    Gerade.EX = i
    Gerade.EY = mYDaten(i)
    If ZeichnePunkt(T, B, L, R, Gerade) Then
        mCanvas.Line (Gerade.AX, Gerade.AY)-(Gerade.EX, Gerade.EY), mLineColor
    End If
Next i

'Zeichnen des Rahmen
mCanvas.Line (L, T)-(R, B), mBorderColor, B

'Border einstellen
mBorder.AX = L
mBorder.AY = T
mBorder.EX = R
mBorder.EY = B

End Function

'Berchnet aus den bergebenen Werten, die PixelPos im Diagramm
'Dabei wird untersucht ob der Wert berhaupt im Berich ist, wenn nur teilweise
'werden die Schnittstellen berechnet, wenn die Punkte ausserhalb des Breichs liegen gibt
'die Funktion False zurck und der Punkt wird nicht gezeichnet
'Die Berechnung der neuen Position, wird mit einer Vektorskalierung durchgefhrt
Private Function ZeichnePunkt(ByVal Top As Double, ByVal Bottom As Double, ByVal Left As Double, ByVal Right As Double, ByRef Gerade As Koord) As Boolean
Dim VX As Double, VY As Double
Dim VT As Double, Fakt As Double

'Fall1 beide Punkte sind ungltig,es wird nichts gezeichnet
If Gerade.AY = conNoData And Gerade.EY = conNoData Then
    ZeichnePunkt = False
    Exit Function
End If
'Fall2 Anfangswert ist ungltig, prfen ob Endwert im Bereich ist
If Gerade.AY = conNoData Then
    If (Gerade.EX < mMinX And Gerade.EX > mMaxX) Or _
       (Gerade.EY < mMinY And Gerade.EY > mMaxY) Then
       'X oder Y Punkt liegen ausserhalb des Bereichs, nicht zeichnen
        ZeichnePunkt = False
        Exit Function
    End If
    'Wert auf Nullpunkt umrechnen = Minx bzw. Miny
    Gerade.EX = Gerade.EX - mMinX
    Gerade.EY = Gerade.EY - mMinY
    'Wert in Pixel-Pos umrechnen
    Gerade.EX = Gerade.EX * mSkalStepX + Left
    Gerade.EY = Bottom - (Gerade.EY * mSkalStepY)
    Gerade.AX = Gerade.EX
    Gerade.AY = Gerade.EY
    ZeichnePunkt = True
    Exit Function
End If
'Fall3 Endwert ist ungltig, prfen ob Endwert im Bereich ist
If Gerade.EY = conNoData Then
    If (Gerade.AX < mMinX And Gerade.AX > mMaxX) Or _
       (Gerade.AY < mMinY And Gerade.AY > mMaxY) Then
       'X oder Y Punkt liegen ausserhalb des Bereichs, nicht zeichnen
        ZeichnePunkt = False
        Exit Function
    End If
    'Wert auf Nullpunkt umrechnen = Minx bzw. Miny
    Gerade.AX = Gerade.AX - mMinX
    Gerade.AY = Gerade.AY - mMinY
    'Wert in Pixel-Pos umrechnen
    Gerade.AX = Gerade.AX * mSkalStepX + Left
    Gerade.AY = Bottom - (Gerade.AY * mSkalStepY)
    Gerade.EX = Gerade.AX
    Gerade.EY = Gerade.AY
    ZeichnePunkt = True
    Exit Function
End If
'Fall4 Beide Werte sind gltig
'Richtungsvektor der Geraden berechnen
VX = Gerade.EX - Gerade.AX
VY = Gerade.EY - Gerade.AY

ZeichnePunkt = True

'Prfe linken Rand
If Gerade.AX < mMinX And Gerade.EX < mMinX Then
    'wenn beide ausserhalb von Bereich, wird nicht gezeichnet
    ZeichnePunkt = False
    Exit Function
ElseIf Gerade.AX < mMinX Then
    'Berechne neuen Linken Rand
    'Berechne neuen Richtungsvektor X,skaliere alten Vektor und berechne YPos
    Gerade.AX = mMinX
    VT = Gerade.EX - Gerade.AX
    If VT = 0 Then
        Fakt = 1
        VY = 0
        VX = 0
    Else
        Fakt = VX / VT
        VY = VY / Fakt
        VX = VX / Fakt
    End If
    Gerade.AY = Gerade.EY - VY
ElseIf Gerade.EX < mMinX Then
    'Berechne neuen Linken Rand
    'Berechne neuen Richtungsvektor X,skaliere alten Vektor und berechne YPos
    Gerade.EX = mMinX
    VT = Gerade.EX - Gerade.AX
    If VT = 0 Then
        Fakt = 1
        VY = 0
        VX = 0
    Else
        Fakt = VX / VT
        VY = VY / Fakt
        VX = VX / Fakt
    End If
    Gerade.EY = Gerade.AY + VY
End If

'Prfe rechten Rand
If Gerade.AX > mMaxX And Gerade.EX > mMaxX Then
    'wenn beide ausserhalb von Bereich, wird nicht gezeichnet
    ZeichnePunkt = False
    Exit Function
ElseIf Gerade.AX > mMaxX Then
    'Berechne neuen rechten Rand
    'Berechne neuen Richtungsvektor X,skaliere alten Vektor und berechne YPos
    Gerade.AX = mMaxX
    VT = Gerade.EX - Gerade.AX
    If VT = 0 Then
        Fakt = 1
        VY = 0
        VX = 0
    Else
        Fakt = VX / VT
        VY = VY / Fakt
        VX = VX / Fakt
    End If
    Gerade.AY = Gerade.EY - VY
ElseIf Gerade.EX > mMaxX Then
    'Berechne neuen rechten Rand
    'Berechne neuen Richtungsvektor X,skaliere alten Vektor und berechne YPos
    Gerade.EX = mMaxX
    VT = Gerade.EX - Gerade.AX
    If VT = 0 Then
        Fakt = 1
        VY = 0
        VX = 0
    Else
        Fakt = VX / VT
        VY = VY / Fakt
        VX = VX / Fakt
    End If
    Gerade.EY = Gerade.AY + VY
End If

'prfe oberen Rand
If Gerade.AY > mMaxY And Gerade.EY > mMaxY Then
    'wenn beide ausserhalb von Bereich, wird nicht gezeichnet
    ZeichnePunkt = False
    Exit Function
ElseIf Gerade.AY > mMaxY Then
    'Berechne neuen oberen Rand
    'Berechne neuen Richtungsvektor Y,skaliere alten Vektor und berechne XPos
    Gerade.AY = mMaxY
    VT = Gerade.EY - Gerade.AY
    If VT = 0 Then
        Fakt = 1
        VY = 0
        VX = 0
    Else
        Fakt = VY / VT
        VY = VY / Fakt
        VX = VX / Fakt
    End If
    Gerade.AX = Gerade.EX - VX
ElseIf Gerade.EY > mMaxY Then
    'Berechne neuen oberen Rand
    'Berechne neuen Richtungsvektor Y,skaliere alten Vektor und berechne XPos
    Gerade.EY = mMaxY
    VT = Gerade.EY - Gerade.AY
    If VT = 0 Then
        Fakt = 1
        VY = 0
        VX = 0
    Else
        Fakt = VY / VT
        VY = VY / Fakt
        VX = VX / Fakt
    End If
    Gerade.EX = Gerade.AX + VX
End If

'prfe unteren Rand
If Gerade.AY < mMinY And Gerade.EY < mMinY Then
    'wenn beide ausserhalb von Bereich, wird nicht gezeichnet
    ZeichnePunkt = False
    Exit Function
ElseIf Gerade.AY < mMinY Then
    'Berechne neuen unteren Rand
    'Berechne neuen Richtungsvektor Y,skaliere alten Vektor und berechne XPos
    Gerade.AY = mMinY
    VT = Gerade.EY - Gerade.AY
    If VT = 0 Then
        Fakt = 1
        VY = 0
        VX = 0
    Else
        Fakt = VY / VT
        VY = VY / Fakt
        VX = VX / Fakt
    End If
    Gerade.AX = Gerade.EX - VX
ElseIf Gerade.EY < mMinY Then
    'Berechne neuen unteren Rand
    'Berechne neuen Richtungsvektor Y,skaliere alten Vektor und berechne XPos
    Gerade.EY = mMinY
    VT = Gerade.EY - Gerade.AY
    If VT = 0 Then
        Fakt = 1
        VY = 0
        VX = 0
    Else
        Fakt = VY / VT
        VY = VY / Fakt
        VX = VX / Fakt
    End If
    Gerade.EX = Gerade.AX + VX
End If

'Wert auf Nullpunkt umrechnen = Minx bzw. Miny
Gerade.AX = Gerade.AX - mMinX
Gerade.AY = Gerade.AY - mMinY
Gerade.EX = Gerade.EX - mMinX
Gerade.EY = Gerade.EY - mMinY
'Wert in Pixel-Pos umrechnen
Gerade.AX = Gerade.AX * mSkalStepX + Left
Gerade.AY = Bottom - (Gerade.AY * mSkalStepY)
Gerade.EX = Gerade.EX * mSkalStepX + Left
Gerade.EY = Bottom - (Gerade.EY * mSkalStepY)

End Function

'Shape-Control fr den Markierungsrahmen
'Wird in Init bergeben
'Beginn der Markierung
Private Sub mCanvas_MouseDown(Button As Integer, Shift As Integer, X As Single, Y As Single)
IsMouseDown = True
mMarkerShape.Visible = True
mMarker.AX = X
mMarker.AY = Y
mMarkerShape.Left = X
mMarkerShape.Width = 1
mMarkerShape.Top = Y
mMarkerShape.Height = 1
End Sub

'Zeichnen des Markierungsrahmen
Private Sub mCanvas_MouseMove(Button As Integer, Shift As Integer, X As Single, Y As Single)
If Not IsMouseDown Then Exit Sub
If X > mMarker.AX Then
    mMarkerShape.Left = mMarker.AX
    mMarkerShape.Width = X - mMarker.AX
Else
    mMarkerShape.Left = X
    mMarkerShape.Width = mMarker.AX - X
End If
If Y > mMarker.AY Then
    mMarkerShape.Top = mMarker.AY
    mMarkerShape.Height = Y - mMarker.AY
Else
    mMarkerShape.Top = Y
    mMarkerShape.Height = mMarker.AY - Y
End If

End Sub

'Ende der Markierung
'Wenn X oder Y ausser der Diagrammflche, dann wird das Diagramm zurckgesetzt
'sonst werden die neuen Grenzen berechnet
Private Sub mCanvas_MouseUp(Button As Integer, Shift As Integer, X As Single, Y As Single)
Dim tmp As Double

If Not IsMouseDown Then Exit Sub
mMarkerShape.Visible = False
IsMouseDown = False
mMarker.EX = X
mMarker.EY = Y

'wenn Ax oder ex auserhalb der border wird das diagramm zurckgesetzt
With mMarker
If .AY < mBorder.AY Or .EY < mBorder.AY Or .AY > mBorder.EY Or .EY > mBorder.EY Then
    Me.AutoYMinMax = True
    Me.AutoXMinMax = True
    Me.Zeichne
ElseIf .AX < mBorder.AX Or .EX < mBorder.AX Or .AX > mBorder.EX Or .EX > mBorder.EX Then
    Me.AutoYMinMax = True
    Me.AutoXMinMax = True
    Me.Zeichne
Else
    'Neue Y Skalierung berechnen
    .AY = (mBorder.EY - .AY) / mSkalStepY
    .EY = (mBorder.EY - .EY) / mSkalStepY
    tmp = mMinY
    mMinY = tmp + IIf(.EY < .AY, .EY, .AY)
    mMaxY = tmp + IIf(.EY > .AY, .EY, .AY)
    Me.AutoYMinMax = False
    'Neue X Skalierung berechnen
    .AX = (.AX - mBorder.AX) / mSkalStepX
    .EX = (.EX - mBorder.AX) / mSkalStepX
    tmp = mMinX
    mMinX = Int(tmp + IIf(.EX < .AX, .EX, .AX))
    mMaxX = Int(tmp + IIf(.EX > .AX, .EX, .AX))
    Me.AutoXMinMax = False
    Me.Zeichne
End If

End With
End Sub

